<template>
  <section class="appMap entitiesMap">
    <header class="appMap-header">
      <slot
        name="heading"
        :entities-count="entitiesCount"
        :selectedTypes="activeTypes"
      />
      <slot
        name="switcher"
      />

      <button
        @click="$emit('show-grids')"
        class="buttonBack">
        Списком
        <img
          svg-inline
          src="~/assets/svg/redesign/arrow-left-bold.svg">
      </button>
      <AppButton
        @click.native="$emit('change-display')"
        :classes="['buttonFilters']">
        <span
          slot="button-item"
          class="button-item">
          <img
            svg-inline
            src="~/assets/svg/redesign/filter-funnel.svg">
          Фильтры
        </span>
      </AppButton>
    </header>
    <AppAbstractMap
      :placemarks="entities"
      :balloon-configuration="$options.balloonСonfiguration"
      :hint-configuration="$options.hintСonfiguration"
      :active-entity-index="activeEntityIndex"
      :init-coords="entities[activeEntityIndex]"
      :can-show-mobile="isMobileDevice"
      :filters="activeTypes"
      :bus="bus">
      <template
        v-if="!filterHidden"
        #filter>
        <AppEntitiesTypeFilter
          :types="activeTypesItems"
          @toggle-filter="onToggleFilter"/>
      </template>
      <template
        v-slot:balloon="{
          markerId,
          balloonEntity,
          balloonPosition,
          balloonDirection,
          balloonConfiguration,
          balloonOpened,
          closeBalloon }">
        <AppMapPopupBalloon
          :marker-id="markerId"
          :balloon-entity="balloonEntity"
          :balloon-position="balloonPosition"
          :balloon-direction="balloonDirection"
          :balloon-configuration="balloonConfiguration"
          :balloon-opened="balloonOpened"
          :with-fast-order="true"
          :class="{'__hidden': !balloonOpened}"
          @close-balloon="closeBalloon"
          @click-fast-order="onFastOrder(markerId)"
        />
      </template>
    </AppAbstractMap>
  </section>
</template>

<script>
import { debounce, isNil } from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import { SHOW_LOCATION_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import Vue from 'vue';
import Grids from '~/assets/js/enums/search-by-number-tabs';
import Placemark from '~/assets/js/enums/placemark';
import OrderDirections from '~/assets/js/enums/order-directions';

import findTabValue from '~/assets/js/helpers/tab-value-by-grid';

import AppAbstractMap from '~/components/redesign/app-map/app-abstract-map';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppEntitiesTypeFilter from '~/components/redesign/app-map/app-entities-type-filter';
import AppEntitiesList from '~/components/redesign/entities/app-entities-list';
import AppEntityOffer from '~/components/redesign/entities/app-entity-offer';
import AppMapHint from '~/components/redesign/app-map/app-map-hint';
import AppWarning from '~/components/redesign/app-warning';
import SelectSorting from '~/components/redesign/app-select/select-sorting';
import AppMapPopupBalloon from '~/components/redesign/app-map/app-map-popup-balloon';

// Mock
import { currentOffer } from '~/assets/js/mocks/table/headings';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'AppEntitiesInMap',
  components: {
    AppAbstractMap,
    AppButton,
    AppEntitiesTypeFilter,
    AppEntitiesList,
    AppEntityOffer,
    AppWarning,
    SelectSorting,
    AppMapPopupBalloon,
  },
  props: {
    location: {
      type: Object,
      default: () => ({
        id: null,
        name: null,
        slug: null,
        level: null,
        prepositionalName: null,
      }),
    },
    partTitle: {
      type: String,
      default: '',
    },
    grid: {
      type: Object,
      default() {
        return {};
      },
    },
    activeTypes: {
      type: Array,
      default() {
        return [Grids.ORIGINALS.tabShow];
      },
    },
  },
  data() {
    const count = this.grid[Grids.ORIGINALS.name].count || 0;

    return {
      // При инициализации списка entities, первый элемент по умолчанию активный
      activeEntityIndex: 0,
      direction: OrderDirections.ASC,
      bus: new Vue(),
      hasList: false,
      screenWidth: null,
      interacted: false,
      // activeTypes: [Grids.ORIGINALS.tabShow],
      entitiesCount: count,
    };
  },
  computed: {
    isMobileDevice() {
      return (this.screenWidth && this.screenWidth < 768) || /Mobi|Android/i.test(navigator.userAgent);
    },
    sortedClass() {
      return this.direction === OrderDirections.ASC ? '-sorting-up' : '-sorting-down';
    },
    entities() {
      return [
        ...this.grid[Grids.ORIGINALS.name].data.map(item => ({ ...item, type: 'originals' })),
        ...this.grid[Grids.COUNTERPART.name].data.map(item => ({ ...item, type: 'analogs' })),
      ];
    },
    filterHidden() {
      return this.grid[Grids.ORIGINALS.name].count === 0
        || this.grid[Grids.COUNTERPART.name].count === 0;
    },
    activeTypesItems() {
      return {
        [Grids.ORIGINALS.tabShow]: { // originals
          name: `- ${this.partTitle}`,
          active: !!this.activeTypes.find(type => type === 'originals'),
        },
        [Grids.COUNTERPART.tabShow]: { // analogs
          name: '- Аналоги и заменители',
          active: !!this.activeTypes.find(type => type === 'analogs'),
        },
      };
    },
    sorting() {
      return this.$options.headingsCurrentOffer
        .filter(entry => entry.sorting.has)
        .reduce((acc, entry) => acc.concat(
          {
            id: `${OrderDirections.ASC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.ASC,
          },
          {
            id: `${OrderDirections.DESC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.DESC,
          }
        ), []);
    },
  },
  watch: {
    entities() {
      this.setEntitesCount();
    },
  },
  created() {
    this.$options.balloonСonfiguration = {
      type: Placemark.OFFER,
      bus: this.bus,
    };
    this.$options.hintСonfiguration = {
      template: AppMapHint,
      type: Placemark.OFFER,
    };
    this.$options.headingsCurrentOffer = currentOffer;
    this.debouncedResizeHandler = debounce(this.onResizeHandler, 250);
    window.addEventListener('resize', this.debouncedResizeHandler);
  },
  mounted() {
    if (!isNil(this.bus)) {
      this.bus.$on('select-entity', ([itemIndex = 0]) => {
        this.activeEntityIndex = itemIndex;
        this.interacted = true;
        this.hasList = false;
      });
    }

    this.entitiesCount = this.grid.AVAILABILITY_RESULT_ORIGINAL.count;
  },
  destroyed() {
    if (!isNil(this.bus)) {
      this.bus.$off('select-entity');
    }

    window.removeEventListener('resize', this.debouncedResizeHandler);
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showLocationModal: SHOW_LOCATION_MODAL,
    }),
    onFastOrder(markerId) {
      const item = this.entities.find(entity => entity.item_id === markerId);

      if (item) {
        this.$emit('fast-order', item);
        this.$statPpn('click-order-quick', this.getItemStatData(item));
        this.$ym('to_order');
        this.$ga('Country1', 'Click32');
      }
    },
    setEntitesCount() {
      if (this.activeTypes.length === 2) {
        this.entitiesCount = this.entites.length;
      } else {
        this.entitiesCount = this.grid[findTabValue(this.activeTypes[0], 'tabShow', 'name')].count;
      }
    },
    getItemStatData(item) {
      return {
        shopId: item.shop_id,
        brandId: item.part_manufacturer_id,
        partId: item.part_id,
        itemId: item.item_id,
        itemName: item.item_name,
        brandName: item.brand,
        partNumber: item.vendor_code,
        partName: item.part_name,
      };
    },
    fetchByOrder(order) {
      this.$emit('order-change', findTabValue(this.activeTab, 'tabShow', 'name'), {
        field: order.field,
        direction: order.direction,
      });
      this.activeEntityIndex = 0;
    },
    onToggleFilter(type) {
      const types = this.activeTypes;
      if (!types.find(item => item === type)) {
        this.$emit('change-active-types', types.concat(type));
        this.entitiesCount = this.grid[Grids.ORIGINALS.name].count
        + this.grid[Grids.COUNTERPART.name].count;
      } else if (
        types.length === Object.values(this.activeTypesItems).length
      ) {
        // this.activeTypes = types.filter((item => item !== type));
        this.$emit('change-active-types', types.filter((item => item !== type)));
        this.entitiesCount -= this.grid[findTabValue(type, 'tabShow', 'name')].count;
      } else {
        const anotherItem = type === Grids.ORIGINALS.tabShow
          ? Grids.COUNTERPART.tabShow
          : Grids.ORIGINALS.tabShow;
        // this.activeTypes = types
        //   .filter((item => item !== type))
        //   .concat(anotherItem);

        this.$emit('change-active-types', types
          .filter((item => item !== type))
          .concat(anotherItem));

        this.entitiesCount = this.grid[findTabValue(anotherItem, 'tabShow', 'name')].count;
      }

      if (!isNil(this.bus)) {
        this.bus.$emit('toggle-filter', this.activeTypes);
      }
    },
    onChooseEntity([index = 0]) {
      this.activeEntityIndex = index;
      this.hasList = false;
      this.interacted = true;
    },
    onResizeHandler() {
      ({ width: this.screenWidth } = window.screen);
    },
  },
};
</script>

<style lang="postcss">
  .appMap.entitiesMap {
    position: relative;
    width: 100%;

    & .multiselectSorting {
      width: fit-content;
      align-self: flex-end;

      @media only screen and ( max-width: 980px ) {
        display: none;
      }

      & .multiselect__tags,
      & .multiselect__placeholder {
        justify-content: flex-end;
        font-size: 0.75rem;
        padding-right: 0.625rem;
      }

      & .multiselect__placeholder {
        padding-right: 1.425rem;
      }

      & .multiselect__clear {
        display: none;
      }
    }

    & .entitiesList.-hide-list {
      @media only screen and ( max-width: 980px ) {
        display: none;
      }
    }

    .appMap-header {
      display: flex;
      justify-content: space-between;
      align-items: flex-end;
      padding: 1rem 0 0.5rem;

      .offers-controlDisplay {
        &.-is-desktop {
          padding: 0;
          margin-bottom: 0;
        }
      }

      .buttonBack, .buttonFilters {
        display: none;
      }
    }

    & .buttonExpanded {
      display: none !important;
    }

    .entities-type-filter {
      position: absolute;
      left: 3rem;
      top: .5rem;
    }

    .entitiesList {
      position: absolute;
      top: 7rem;

      & .appWarning-wrapper .paragraph {
        text-align: left;
      }

      &-options {

        .buttonAsLink {
          padding: 0 1.25rem;
          height: 2.5rem;
          color: var(--color-main);

          .button-item {
            display: flex;
            align-items: center;

            &.-sorting-up,
            &.-sorting-down {
              font-size: 0.6875rem;
            }
          }

          .svg {
            margin-left: 0.25rem;
            width: 0.5625rem;
            height: 0.25rem;
            fill: var(--color-main-lightest);
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      position: fixed;
      z-index: calc(var(--z-index-over-modal) - 1);
      top: 0;
      bottom: 0;
      left: 0;
      width: 100vw;
      min-width: 20rem;
      height: 100vh;

      .appMap-header {
        position: absolute;
        display: flex;
        z-index: 1;
        top: 0;
        width: 100vw;
        min-width: 20rem;

        .button, .heading {
          display: none;
        }

        .buttonBack {
          position: absolute;
          top: 2.75rem;
          left: 0.5rem;
          display: block;
          width: 3.75rem;
          height: 3.75rem;
          font-size: 0;
          border: none;
          outline: none;
          border-radius: 50%;
          background-color: rgba(255,255,255,0.8);
          box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);

          .svg {
            fill: var(--color-main);
          }
        }

        .buttonFilters {
          position: absolute;
          top: 2.75rem;
          right: 0.5rem;
          display: flex;
          background-color: rgba(255,255,255,0.8);
          box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);

          .button-item {
            display: inline-flex;
            align-items: center;
            font-size: 1rem;
            font-weight: var(--font-weight-medium);
          }

          .svg {
            margin-right: 0.5rem;
            width: 1rem;
            height: auto;
            fill: var(--color-main);
          }
        }
      }

      .entities-type-filter {
        top: 7.25rem;
        left: auto;
        right: .5rem;
      }

      .entitiesList {
        position: absolute;
        top: auto;
        bottom: 0;
        height: auto;
        width: 100vw;
        min-width: 20rem;

        &-options {
          justify-content: flex-start;

          .buttonAsLink {
            height: 4rem;
            color: var(--color-main-lightest);

            .button-item {
              font-size: 1rem;
            }

            .svg {
              margin-left: 0.5rem;
              width: 0.75rem;
              height: 0.375rem;
            }
          }
        }
      }
    }
  }
</style>
